<?php

// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

/**
 * BufferApp Settings
 *
 * The html markup for the BufferApp settings tab.
 *
 * @package Social Auto Poster
 * @since 2.6.9
 */

global $wpw_auto_poster_reposter_options, $wpw_auto_poster_model;

//model class
$model = $wpw_auto_poster_model;

$cat_posts_type = !empty( $wpw_auto_poster_reposter_options['ba_posting_cats'] ) ? $wpw_auto_poster_reposter_options['ba_posting_cats']: 'include';

$ba_exclude_cats = array();

// Get saved categories for ba to exclude from posting
if( !empty( $wpw_auto_poster_reposter_options['ba_post_type_cats'] ) ) {
	$ba_exclude_cats = $wpw_auto_poster_reposter_options['ba_post_type_cats'];
}

$ba_last_posted_page = ( !empty( $wpw_auto_poster_reposter_options['ba_last_posted_page'] ) ) ? $wpw_auto_poster_reposter_options['ba_last_posted_page'] : '1';

$exludes_post_ids = !empty( $wpw_auto_poster_reposter_options['ba_post_ids_exclude']) ? $wpw_auto_poster_reposter_options['ba_post_ids_exclude'] : '';

$repost_ba_global_message_template = isset( $wpw_auto_poster_reposter_options['repost_ba_global_message_template'] ) ? $wpw_auto_poster_reposter_options['repost_ba_global_message_template'] : '';

$repost_ba_custom_msg_options = isset( $wpw_auto_poster_reposter_options['repost_ba_custom_msg_options'] ) ? $wpw_auto_poster_reposter_options['repost_ba_custom_msg_options'] : 'global_msg';

if( $repost_ba_custom_msg_options == 'global_msg') {
	$post_msg_style = "display:none";
	$global_msg_style = "";
} else{
	$global_msg_style = "display:none";
	$post_msg_style = "";
}

?>

<!-- beginning of the bufferapp general settings meta box -->
<div id="wpw-auto-poster-bufferapp-general" class="post-box-container">
	<div class="metabox-holder">	
		<div class="meta-box-sortables ui-sortable">
			<div id="bufferapp_general" class="postbox">	
				<div class="handlediv" title="<?php _e( 'Click to toggle', 'wpwautoposter' ); ?>"><br /></div>
								
					<h3 class="hndle">
						<span style='vertical-align: top;'><?php _e( 'BufferApp Settings', 'wpwautoposter' ); ?></span>
					</h3>
									
					<div class="inside">
										
						<table class="form-table">											
							<tbody>
								<tr valign="top">
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[enable_bufferapp]"><?php _e( 'Repost to BufferApp:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<input name="wpw_auto_poster_reposter_options[enable_bufferapp]" id="wpw_auto_poster_reposter_options[enable_bufferapp]" type="checkbox" value="1" <?php if( isset( $wpw_auto_poster_reposter_options['enable_bufferapp'] ) ) { checked( '1', $wpw_auto_poster_reposter_options['enable_bufferapp'] ); } ?> />
										<p><small><?php _e( 'Check this box, if you want to autopost your content to BufferApp.', 'wpwautoposter' ); ?></small></p>
									</td>
								</tr>	

								<tr valign="top">
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[enable_bufferapp_for]"><?php _e( 'Repost for:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<ul>
										<?php 
											$all_types = get_post_types( array( 'public' => true ), 'objects');
											$all_types = is_array( $all_types ) ? $all_types : array();
											
											if( !empty( $wpw_auto_poster_reposter_options['enable_bufferapp_for'] ) ) {
												$prevent_meta = $wpw_auto_poster_reposter_options['enable_bufferapp_for'];
											} else {
												$prevent_meta = '';
											}
															
											$prevent_meta = is_array( $prevent_meta ) ? $prevent_meta : array();


											if( !empty( $wpw_auto_poster_reposter_options['ba_post_type_cats'] ) ) {
												$ba_post_type_cats = $wpw_auto_poster_reposter_options['ba_post_type_cats'];
											} else {
												$ba_post_type_cats = array();
											}

														
											foreach ( $all_types as $type ) {	
															
												if ( !is_object( $type ) ) continue;															
													$label = @$type->labels->name ? $type->labels->name : $type->name;
													if( $label == 'Media' || $label == 'media' ) continue; // skip media
													$selected = ( in_array( $type->name, $prevent_meta ) ) ? 'checked="checked"' : '';
										?>
															
											<li class="wpw-auto-poster-prevent-types">
												<input type="checkbox" id="wpw_auto_posting_ba_prevent_<?php echo $type->name; ?>" name="wpw_auto_poster_reposter_options[enable_bufferapp_for][]" value="<?php echo $type->name; ?>" <?php echo $selected; ?>/>
																						
												<label for="wpw_auto_posting_ba_prevent_<?php echo $type->name; ?>"><?php echo $label; ?></label>
											</li>
											
											<?php	} ?>
										</ul>
										<p><small><?php _e( 'Check each of the post types that you want to post automatically to BufferApp.', 'wpwautoposter' ); ?></small></p>  
									</td>
								</tr> 
								
								<tr valign="top">
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[ba_post_type_cats][]"><?php _e( 'Select Taxonomies:', 'wpwautoposter' ); ?></label> 
									</th>
									<td class="wpw-auto-poster-select">
										<div class="wpw-auto-poster-cats-option">
											<input name="wpw_auto_poster_reposter_options[ba_posting_cats]" id="ba_cats_include" type="radio" value="include" <?php checked( 'include', $cat_posts_type ); ?> />
											<label for="ba_cats_include"><?php _e( 'Include (Post only with)', 'wpwautoposter');?></label>
											<input name="wpw_auto_poster_reposter_options[ba_posting_cats]" id="ba_cats_exclude" type="radio" value="exclude" <?php checked( 'exclude', $cat_posts_type ); ?> />
											<label for="ba_cats_exclude"><?php _e( 'Exclude (Do not post)', 'wpwautoposter');?></label>
										</div>
										<select name="wpw_auto_poster_reposter_options[ba_post_type_cats][]" id="wpw_auto_poster_reposter_options[ba_post_type_cats]" class="ba_post_type_cats wpw-auto-poster-cats-tags-select" multiple="multiple">
											<?php

												$post_type_categories = wpw_auto_poster_get_all_categories_and_tags();

												if(!empty($post_type_categories)) {
													
													foreach($post_type_categories as $post_type => $post_data){

														echo '<optgroup label="'.$post_data['label'].'">';

														if(isset($post_data['categories']) && !empty($post_data['categories']) && is_array($post_data['categories'])){
															
															foreach($post_data['categories'] as $cat_slug => $cat_name){

																$selected ='';
																if( !empty( $ba_exclude_cats[$post_type] ) ) {
											                		$selected = ( in_array( $cat_slug, $ba_exclude_cats[$post_type] ) ) ? 'selected="selected"' : '';
											                	}
											                	
																echo '<option value="' . $post_type ."|".$cat_slug . '" '.$selected.'>'.$cat_name.'</option>';
															}

														}
														echo '</optgroup>';
													}
												}

											?>
										</select>
										<div class="wpw-ajax-loader"><img src="<?php echo WPW_AUTO_POSTER_IMG_URL."/icons/ajax-loader.gif";?>"/></div>
										<p><small><?php _e( 'Select the Taxonomies for each post type that you want to include or exclude for the repost.', 'wpwautoposter' ); ?></small></p>
									</td>
								</tr>
								<tr valign="top">
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[ba_post_ids_exclude]"><?php _e( 'Exclude Posts:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<textarea placeholder="1100,1200,1300" cols="35" id="wpw_auto_poster_reposter_options[ba_post_ids_exclude]" name="wpw_auto_poster_reposter_options[ba_post_ids_exclude]"><?php echo $exludes_post_ids; ?></textarea>
										<p><small>
											<?php _e( 'Enter the post ids seprated by comma(,) which you want to exclude for the posting.', 'wpwautoposter' ); ?>
										</small></p>
									</td>
								</tr>
								<tr valign="top" class="wpw-auto-poster-schedule-limit">
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[ba_posts_limit]"><?php _e( 'Maximum Posting per schedule:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<input id="wpw_auto_poster_reposter_options[ba_posts_limit]" name="wpw_auto_poster_reposter_options[ba_posts_limit]" type="text" value="<?php echo $wpw_auto_poster_reposter_options['ba_posts_limit']; ?>" />
										<p><small>
											<?php _e( 'Enter the maximum auto posting allowed on each schedule execution. Leave it empty for unlimited posting.', 'wpwautoposter' ); ?>
										</small></p>
									</td>
								</tr>

								<tr valign="top">
									<th scope="row">
										<label><?php _e( 'Custom Message Option:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<input id="ba_custom_global_msg" type="radio" name="wpw_auto_poster_reposter_options[repost_ba_custom_msg_options]" value="global_msg" <?php checked($repost_ba_custom_msg_options, 'global_msg', true);?>>
										<label for="ba_custom_global_msg" class="wpw-auto-poster-label"><?php _e( 'Global', 'wpwautoposter' ); ?></label>
	                                    
	                                    <input id="ba_custom_post_msg" type="radio" name="wpw_auto_poster_reposter_options[repost_ba_custom_msg_options]" value="post_msg" <?php checked($repost_ba_custom_msg_options, 'post_msg', true);?>>
	                                    <label for="ba_custom_post_msg" class="wpw-auto-poster-label"><?php _e( 'Individual Post Type Message', 'wpwautoposter' ); ?></label>
									</td>	
								</tr>
								<tr valign="top" style="<?php echo $global_msg_style; ?>" class="global_msg_tr">									
									<th scope="row">
										<label for="wpw_auto_poster_reposter_options[repost_ba_global_message_template]"><?php _e( 'Custom Message:', 'wpwautoposter' ); ?></label>
									</th>
									<td>
										<textarea type="text" name="wpw_auto_poster_reposter_options[repost_ba_global_message_template]" id="wpw_auto_poster_reposter_options[repost_ba_global_message_template]" class="large-text"><?php echo $model->wpw_auto_poster_escape_attr( $repost_ba_global_message_template ); ?></textarea>
									</td>	
								</tr>
								<?php
									$all_types = get_post_types( array( 'public' => true ), 'objects');
									$all_types = is_array( $all_types ) ? $all_types : array();

									foreach( $all_types as $type ) {	
										
										if( !is_object( $type ) ) continue;															
										$label = @$type->labels->name ? $type->labels->name : $type->name;

										if( $label == 'Media' || $label == 'media' ) continue; // skip media
											
										$wpw_auto_poster_reposter_options['repost_ba_global_message_template_'.$type->name] = ( isset( $wpw_auto_poster_reposter_options['repost_ba_global_message_template_'.$type->name] ) ) ? $wpw_auto_poster_reposter_options['repost_ba_global_message_template_'.$type->name] : '';
									?>
													
									<tr valign="top" style="<?php echo $post_msg_style; ?>" class="post_msg_tr">

										<th scope="row">
											<label for="wpw_auto_posting_ba_custom_msg_<?php echo $type->name; ?>"><?php echo $label; ?>:</label>
										</th>

										<td>
											<textarea type="text" name="wpw_auto_poster_reposter_options[repost_ba_global_message_template_<?php echo $type->name; ?>]" id="wpw_auto_posting_ba_custom_msg_<?php echo $type->name; ?>" class="large-text"><?php echo $model->wpw_auto_poster_escape_attr( $wpw_auto_poster_reposter_options['repost_ba_global_message_template_'.$type->name] ); ?></textarea>
											<p><small><?php _e('Leave it empty for global custom message.','wpwautoposter');?></small></p>
										</td>	
									</tr>
									
									<?php }
								?>
								<tr valign="top">									
									<th scope="row"></th>
									<td>
										<p><small style="line-height: 20px;"><?php _e( 'Here you can enter default message which will be used for the posting on BufferApp. Leave it empty to use the post level message. You can use following template tags within the message template:', 'wpwautoposter' ); ?>
										<?php 
										$ba_template_str = '<br /><code>{first_name}</code> - ' . __('displays the first name,', 'wpwautoposter') .
							            '<br /><code>{last_name}</code> - ' . __('displays the last name,', 'wpwautoposter') .
							            '<br /><code>{title}</code> - ' . __('displays the default post title,', 'wpwautoposter') .
							            '<br /><code>{link}</code> - ' . __('displays the default post link,', 'wpwautoposter') .
							            '<br /><code>{full_author}</code> - ' . __('displays the full author name,', 'wpwautoposter') .
							            '<br /><code>{nickname_author}</code> - ' . __('displays the nickname of author,', 'wpwautoposter') .
							            '<br /><code>{post_type}</code> - ' . __(' displays the post type,', 'wpwautoposter') .
							            '<br /><code>{sitename}</code> - ' . __('displays the name of your site,', 'wpwautoposter') .
							            '<br /><code>{excerpt}</code> - ' . __('displays the post excerpt.', 'wpwautoposter').
							            '<br /><code>{hashtags}</code> - ' . __('displays the post tags as hashtags.', 'wpwautoposter').
							            '<br /><code>{hashcats}</code> - ' . __('displays the post categories as hashtags.', 'wpwautoposter').
							            '<br /><code>{content}</code> - ' . __('displays the post content.', 'wpwautoposter').
							            '<br /><code>{content-digits}</code> - ' . __('displays the post content with define number of digits in template tag. <b>E.g. If you add template like {content-100} then it will display first 100 characters from post content.</b>', 'wpwautoposter').
							            '<br /><code>{CF-CustomFieldName}</code> - ' . __('inserts the contents of the custom field with the specified name. <b>E.g. If your price is stored in the custom field "PRDPRICE" you will need to use {CF-PRDPRICE} tag.</b>', 'wpwautoposter');

							            print $ba_template_str;
							            ?>
										</small></p>
									</td>	
								</tr>

								<?php
									echo apply_filters ( 
													 'wpweb_reposter_ba_settings_submit_button', 
													 '<tr valign="top">
															<td colspan="2">
																<input type="submit" value="' . __( 'Save Changes', 'wpwautoposter' ) . '" id="wpw_auto_poster_reposter_set_submit" name="wpw_auto_poster_reposter_set_submit" class="button-primary">
															</td>
														</tr>'
													);
								?> 													
							</tbody>
						</table>
						<input type="hidden" name="wpw_auto_poster_reposter_options[ba_last_posted_page]" value="<?php print $ba_last_posted_page;?>">				
					</div><!-- .inside -->
									
			</div><!-- #bufferapp_general -->
		</div><!-- .meta-box-sortables ui-sortable -->
	</div><!-- .metabox-holder -->
</div><!-- #wpw-auto-poster-bufferapp-general -->
<!-- end of the bufferapp general settings meta box -->
