<?php
// Exit if accessed directly
if (!defined('ABSPATH'))
    exit;

/**
 * Twitter Settings
 *
 * The html markup for the Twitter settings tab.
 *
 * @package Social Auto Poster
 * @since 2.6.9
 */
global $wpw_auto_poster_reposter_options, $wpw_auto_poster_model;

//model class
$model = $wpw_auto_poster_model;
$cat_posts_type = !empty( $wpw_auto_poster_reposter_options['tw_posting_cats'] ) ? $wpw_auto_poster_reposter_options['tw_posting_cats']: 'include';

$tw_exclude_cats = array();

// Get saved categories for tw to exclude from posting
if( !empty( $wpw_auto_poster_reposter_options['tw_post_type_cats'] ) ) {
    $tw_exclude_cats = $wpw_auto_poster_reposter_options['tw_post_type_cats'];
}

$tw_last_posted_page = ( !empty( $wpw_auto_poster_reposter_options['tw_last_posted_page'] ) ) ? $wpw_auto_poster_reposter_options['tw_last_posted_page'] : '1';

$exludes_post_ids = !empty( $wpw_auto_poster_reposter_options['tw_post_ids_exclude']) ? $wpw_auto_poster_reposter_options['tw_post_ids_exclude'] : '';

$repost_tw_global_message_template = isset( $wpw_auto_poster_reposter_options['repost_tw_global_message_template'] ) ? $wpw_auto_poster_reposter_options['repost_tw_global_message_template'] : '';

$repost_tw_custom_msg_options = isset( $wpw_auto_poster_reposter_options['repost_tw_custom_msg_options'] ) ? $wpw_auto_poster_reposter_options['repost_tw_custom_msg_options'] : 'global_msg';

if( $repost_tw_custom_msg_options == 'global_msg') {
    $post_msg_style = "display:none";
    $global_msg_style = "";
} else{
    $global_msg_style = "display:none";
    $post_msg_style = "";
}

?>

<!-- beginning of the twitter general settings meta box -->
<div id="wpw-auto-poster-twitter-general" class="post-box-container">
    <div class="metabox-holder">	
        <div class="meta-box-sortables ui-sortable">
            <div id="twitter_general" class="postbox">	
                <div class="handlediv" title="<?php _e('Click to toggle', 'wpwautoposter'); ?>"><br /></div>

                <h3 class="hndle">
                    <span style='vertical-align: top;'><?php _e('Twitter Settings', 'wpwautoposter'); ?></span>
                </h3>

                <div class="inside">

                    <table class="form-table">											
                        <tbody>										
                            <tr valign="top">
                                <th scope="row">
                                    <label for="wpw_auto_poster_reposter_options[enable_twitter]"><?php _e('Repost to Twitter:', 'wpwautoposter'); ?></label>
                                </th>
                                <td>
                                    <input name="wpw_auto_poster_reposter_options[enable_twitter]" id="wpw_auto_poster_reposter_options[enable_twitter]" type="checkbox" value="1" <?php if (isset($wpw_auto_poster_reposter_options['enable_twitter'])) {
    checked('1', $wpw_auto_poster_reposter_options['enable_twitter']);
} ?> />
                                    <p><small><?php _e('Check this box, if you want to automatically post your new content to Twitter.', 'wpwautoposter'); ?></small></p>
                                </td>
                            </tr>	

                            <tr valign="top">
                                <th scope="row">
                                    <label for="wpw_auto_poster_reposter_options[enable_twitter_for]"><?php _e('Repost for:', 'wpwautoposter'); ?></label>
                                </th>
                                <td>
                                    <ul>
                                        <?php
                                        $all_types = get_post_types(array('public' => true), 'objects');
                                        $all_types = is_array($all_types) ? $all_types : array();

                                        if (!empty($wpw_auto_poster_reposter_options['enable_twitter_for'])) {
                                            $prevent_meta = $wpw_auto_poster_reposter_options['enable_twitter_for'];
                                        } else {
                                            $prevent_meta = '';
                                        }

                                        $prevent_meta = is_array($prevent_meta) ? $prevent_meta : array();

                                        
                                        if( !empty( $wpw_auto_poster_reposter_options['tw_post_type_cats'] ) ) {
                                            $tw_post_type_cats = $wpw_auto_poster_reposter_options['tw_post_type_cats'];
                                        } else {
                                            $tw_post_type_cats = array();
                                        }

                                        

                                        foreach ($all_types as $type) {

                                            if (!is_object($type))
                                                continue;
                                            $label = @$type->labels->name ? $type->labels->name : $type->name;
                                            if ($label == 'Media' || $label == 'media')
                                                continue; // skip media
                                            $selected = ( in_array($type->name, $prevent_meta) ) ? 'checked="checked"' : '';
                                            ?>

                                            <li class="wpw-auto-poster-prevent-types">
                                                <input type="checkbox" id="wpw_auto_posting_twitter_prevent_<?php echo $type->name; ?>" name="wpw_auto_poster_reposter_options[enable_twitter_for][]" value="<?php echo $type->name; ?>" <?php echo $selected; ?>/>

                                                <label for="wpw_auto_posting_twitter_prevent_<?php echo $type->name; ?>"><?php echo $label; ?></label>
                                            </li>

<?php } ?>
                                    </ul>
                                    <p><small><?php _e('Check each of the post types that you want to post automatically to Twitter.', 'wpwautoposter'); ?></small></p>  
                                </td>
                            </tr>

                            <tr valign="top">
                                    <th scope="row">
                                        <label for="wpw_auto_poster_reposter_options[tw_post_type_cats][]"><?php _e( 'Select Taxonomies:', 'wpwautoposter' ); ?></label> 
                                    </th>
                                    <td class="wpw-auto-poster-select">
                                        <div class="wpw-auto-poster-cats-option">
                                            <input name="wpw_auto_poster_reposter_options[tw_posting_cats]" id="tw_cats_include" type="radio" value="include" <?php checked( 'include', $cat_posts_type ); ?> />
                                            <label for="tw_cats_include"><?php _e( 'Include (Post only with)', 'wpwautoposter');?></label>
                                            <input name="wpw_auto_poster_reposter_options[tw_posting_cats]" id="tw_cats_exclude" type="radio" value="exclude" <?php checked( 'exclude', $cat_posts_type ); ?> />
                                            <label for="tw_cats_exclude"><?php _e( 'Exclude (Do not post)', 'wpwautoposter');?></label>
                                        </div>
                                        <select name="wpw_auto_poster_reposter_options[tw_post_type_cats][]" id="wpw_auto_poster_reposter_options[tw_post_type_cats]" class="tw_post_type_cats wpw-auto-poster-cats-tags-select" multiple="multiple">
                                            <?php

                                                $post_type_categories = wpw_auto_poster_get_all_categories_and_tags();

                                                if(!empty($post_type_categories)) {
                                                    
                                                    foreach($post_type_categories as $post_type => $post_data){

                                                        echo '<optgroup label="'.$post_data['label'].'">';

                                                        if(isset($post_data['categories']) && !empty($post_data['categories']) && is_array($post_data['categories'])){
                                                            
                                                            foreach($post_data['categories'] as $cat_slug => $cat_name){

                                                                $selected ='';
                                                                if( !empty( $tw_exclude_cats[$post_type] ) ) {
                                                                    $selected = ( in_array( $cat_slug, $tw_exclude_cats[$post_type] ) ) ? 'selected="selected"' : '';
                                                                }
                                                                
                                                                echo '<option value="' . $post_type ."|".$cat_slug . '" '.$selected.'>'.$cat_name.'</option>';
                                                            }

                                                        }
                                                        echo '</optgroup>';
                                                    }
                                                }

                                            ?>
                                        </select>
                                        <div class="wpw-ajax-loader"><img src="<?php echo WPW_AUTO_POSTER_IMG_URL."/icons/ajax-loader.gif";?>"/></div>
                                        <p><small><?php _e( 'Select the Taxonomies for each post type that you want to include or exclude for the repost.', 'wpwautoposter' ); ?></small></p>
                                    </td>
                                </tr>

                                <?php do_action('wpw_auto_poster_after_reposter_categories_field_tw');?>
                                
                                <tr valign="top">
                                    <th scope="row">
                                        <label for="wpw_auto_poster_reposter_options[tw_post_ids_exclude]"><?php _e( 'Exclude Posts:', 'wpwautoposter' ); ?></label>
                                    </th>
                                    <td>
                                        <textarea placeholder="1100,1200,1300" cols="35" id="wpw_auto_poster_reposter_options[tw_post_ids_exclude]" name="wpw_auto_poster_reposter_options[tw_post_ids_exclude]"><?php echo $exludes_post_ids; ?></textarea>
                                        <p><small>
                                            <?php _e( 'Enter the post ids seprated by comma(,) which you want to exclude for the posting.', 'wpwautoposter' ); ?>
                                        </small></p>
                                    </td>
                                </tr>
                                <tr valign="top" class="wpw-auto-poster-schedule-limit">
                                    <th scope="row">
                                        <label for="wpw_auto_poster_reposter_options[tw_posts_limit]"><?php _e( 'Maximum Posting per schedule:', 'wpwautoposter' ); ?></label>
                                    </th>
                                    <td>
                                        <input id="wpw_auto_poster_reposter_options[tw_posts_limit]" name="wpw_auto_poster_reposter_options[tw_posts_limit]" type="text" value="<?php echo $wpw_auto_poster_reposter_options['tw_posts_limit']; ?>" />
                                        <p><small>
                                            <?php _e( 'Enter the maximum auto posting allowed on each schedule execution. Leave it empty for unlimited posting.', 'wpwautoposter' ); ?>
                                        </small></p>
                                    </td>
                                </tr>


                                <tr valign="top">
                                    <th scope="row">
                                        <label><?php _e( 'Custom Message Option:', 'wpwautoposter' ); ?></label>
                                    </th>
                                    <td>
                                        <input id="tw_custom_global_msg" type="radio" name="wpw_auto_poster_reposter_options[repost_tw_custom_msg_options]" value="global_msg" <?php checked($repost_tw_custom_msg_options, 'global_msg', true);?>>
                                        <label for="tw_custom_global_msg" class="wpw-auto-poster-label"><?php _e( 'Global', 'wpwautoposter' ); ?></label>
                                        
                                        <input id="tw_custom_post_msg" type="radio" name="wpw_auto_poster_reposter_options[repost_tw_custom_msg_options]" value="post_msg" <?php checked($repost_tw_custom_msg_options, 'post_msg', true);?>>
                                        <label for="tw_custom_post_msg" class="wpw-auto-poster-label"><?php _e( 'Individual Post Type Message', 'wpwautoposter' ); ?></label>
                                    </td>   
                                </tr>
                                <tr valign="top" style="<?php echo $global_msg_style; ?>" class="global_msg_tr">                                    
                                    <th scope="row">
                                        <label for="wpw_auto_poster_reposter_options[repost_tw_global_message_template]"><?php _e( 'Custom Message:', 'wpwautoposter' ); ?></label>
                                    </th>
                                    <td>
                                        <textarea type="text" name="wpw_auto_poster_reposter_options[repost_tw_global_message_template]" id="wpw_auto_poster_reposter_options[repost_tw_global_message_template]" class="large-text"><?php echo $model->wpw_auto_poster_escape_attr( $repost_tw_global_message_template ); ?></textarea>
                                    </td>   
                                </tr>
                                <?php
                                    $all_types = get_post_types( array( 'public' => true ), 'objects');
                                    $all_types = is_array( $all_types ) ? $all_types : array();

                                    foreach( $all_types as $type ) {    
                                        
                                        if( !is_object( $type ) ) continue;                                                         
                                        $label = @$type->labels->name ? $type->labels->name : $type->name;

                                        if( $label == 'Media' || $label == 'media' ) continue; // skip media
                                            
                                        $wpw_auto_poster_reposter_options['repost_tw_global_message_template_'.$type->name] = ( isset( $wpw_auto_poster_reposter_options['repost_tw_global_message_template_'.$type->name] ) ) ? $wpw_auto_poster_reposter_options['repost_tw_global_message_template_'.$type->name] : '';
                                    ?>
                                                    
                                    <tr valign="top" style="<?php echo $post_msg_style; ?>" class="post_msg_tr">

                                        <th scope="row">
                                            <label for="wpw_auto_posting_tw_custom_msg_<?php echo $type->name; ?>"><?php echo $label; ?>:</label>
                                        </th>

                                        <td>
                                            <textarea type="text" name="wpw_auto_poster_reposter_options[repost_tw_global_message_template_<?php echo $type->name; ?>]" id="wpw_auto_posting_tw_custom_msg_<?php echo $type->name; ?>" class="large-text"><?php echo $model->wpw_auto_poster_escape_attr( $wpw_auto_poster_reposter_options['repost_tw_global_message_template_'.$type->name] ); ?></textarea>
                                            <p><small><?php _e('Leave it empty for global custom message.','wpwautoposter');?></small></p>
                                        </td>   
                                    </tr>
                                    
                                    <?php }
                                ?>
                                <tr valign="top">                               
                                    <th scope="row"></th>
                                    <td>
                                        <p><small style="line-height: 20px;"><?php _e( 'Here you can enter custom tweet template which will be used for the tweet. Leave it empty to use the post level tweet. You can use following template tags within the tweet template:', 'wpwautoposter' ); ?>
                                        <?php 
                                            $tw_template_str = '<br /><code>{title}</code> - ' . __('displays the default post title,', 'wpwautoposter') .
                                             '<br /><code>{link}</code> - ' . __('displays the default post link,', 'wpwautoposter') .
                                             '<br /><code>{full_author}</code> - ' . __('displays the full author name,', 'wpwautoposter') .
                                             '<br /><code>{nickname_author}</code> - ' . __('displays the nickname of author,', 'wpwautoposter') .
                                             '<br /><code>{post_type}</code> - ' . __(' displays the post type,', 'wpwautoposter') .
                                             '<br /><code>{excerpt}</code> - ' . __('displays the post excerpt.', 'wpwautoposter').
                                             '<br /><code>{hashtags}</code> - ' . __('displays the post tags as hashtags.', 'wpwautoposter').
                                            '<br /><code>{hashcats}</code> - ' . __('displays the post categories as hashtags.', 'wpwautoposter').
                                            '<br /><code>{content}</code> - ' . __('displays the post content.', 'wpwautoposter').
                                            '<br /><code>{content-digits}</code> - ' . __('displays the post content with define number of digits in template tag. <b>E.g. If you add template like {content-100} then it will display first 100 characters from post content.</b>', 'wpwautoposter').
                                            '<br /><code>{CF-CustomFieldName}</code> - ' . __('inserts the contents of the custom field with the specified name. <b>E.g. If your price is stored in the custom field "PRDPRICE" you will need to use {CF-PRDPRICE} tag.</b>', 'wpwautoposter');
                                            print $tw_template_str;
                                            ?>
                                        </small></p>
                                    </td>
                                </tr>

                            <?php
                            echo apply_filters(
                                    'wpweb_reposter_tw_settings_submit_button', '<tr valign="top">
																<td colspan="2">
																	<input type="submit" value="' . __('Save Changes', 'wpwautoposter') . '" id="wpw_auto_poster_reposter_set_submit" name="wpw_auto_poster_reposter_set_submit" class="button-primary">
																</td>
															</tr>'
                            );
                            ?>
                        </tbody>
                    </table>
                <input type="hidden" name="wpw_auto_poster_reposter_options[tw_last_posted_page]" value="<?php print $tw_last_posted_page;?>">

                </div><!-- .inside -->

            </div><!-- #twitter_general -->
        </div><!-- .meta-box-sortables ui-sortable -->
    </div><!-- .metabox-holder -->
</div><!-- #wpw-auto-poster-twitter-general -->
<!-- end of the twitter general settings meta box -->